/* dcast_control.c
   dreamcast asteroids v0.0.4: 2 players

 by
 jimbo
 Dan Potter and Jordan DeLong of Cryptic Allusion
 Andrew K.
 Marcus Comstedt
*/
//#include "dcasteroids.h"



/*** Dan Potter's code in macro form ***/
/* This weird logic is to avoid bouncing back
   and forth before the user lets go of the
   button. */
#define PRESSED( x, y ) if (!(cond.buttons & x )) { \
	if (!(y & 0x1000)) {

#define PRESSED2( x, y, z ) if (  (!(cond.buttons & x)) && \
          (!(cond.buttons & y)) ) { if (!(z & 0x1000)) {

#define DESSERP( y ) if (y == 0) y = 0x1001; else y = 0x1000; } }



/* v0.0.6: separate from regular control - dont turn while game is paused
 *
 *
 */
void check_pause( shooter_t *p, cont_cond_t cond ) {

    /* v0.0.4: first check for pause
     *
     *
     *
     */
    if (!(cond.buttons & CONT_START)) {
        /* This weird logic is to avoid bouncing back
           and forth before the user lets go of the
           button. */
        if (!(p->transstart & 0x1000)) {
            
#if 1
            /*** v0.0.6: resurrection condition ***/
            if ( p->living == 0 ) {
                p->living = 1;
                p->hull_integrity = MAX_HULL_INTEGRITY;
                p->velocity[0] = 
                  p->velocity[1] = 
                    p->velocity[2] = 0.0;
            }
            else {
                p->pausing = 1 - p->pausing;
            }
#endif
            //          p->pausing = 1 - p->pausing;


            if (p->transstart == 0)
                p->transstart = 0x1001;
            else
                p->transstart = 0x1000;
        }
    } else {
        p->transstart &= ~0x1000;
    }
    
}



/* v0.0.6: separate from regular control - dont turn while game is paused
 *
 *
 */
void process_prefs_input( shooter_t *p, cont_cond_t cond ) {


    check_pause( p, cond );
    
    /*** v0.0.4: prefs interface ***/
    if ( p->pausing == 1 ) {
        


            if (!(cond.buttons & CONT_X)) {
            /* This weird logic is to avoid bouncing back
               and forth before the user lets go of the
               button. */
                if (!(p->transview & 0x1000)) {
                
                    p->chosen_view = 1 - p->chosen_view;


                    if (p->transview == 0)
                        p->transview = 0x1001;
                    else
                        p->transview = 0x1000;
                }
            } else {
                p->transview &= ~0x1000;
            }






        if (!(cond.buttons & CONT_Y)) {
            p->chosen_option = 0;
        }

        if (!(cond.buttons & CONT_X)) {
            p->chosen_option = 1;
        }

        if (!(cond.buttons & CONT_B)) {
            p->chosen_option = 2;
        }

        if (!(cond.buttons & CONT_A)) {
            p->chosen_option = 3;
        }

        if (!(cond.buttons & CONT_DPAD_LEFT) ){
            switch( p->chosen_option ) {

            case 0:
                if ( p->sensitivity_wide > 1 ) {
                    p->sensitivity_wide--;
                }
                break;

            case 1:
                if ( p->sensitivity_tight > 1 ) {
                    p->sensitivity_tight--;
                }
                break;


            case 2:
                if ( p->fov_wide > 1 ) {
                    p->fov_wide--;
                }
                break;

            case 3:
                if ( p->fov_tight > 1 ) {
                    p->fov_tight--;
                }
                break;



            default: break;
            }

        }
        if (!(cond.buttons & CONT_DPAD_RIGHT)) {
            switch( p->chosen_option ) {

            case 0:
                if ( p->sensitivity_wide < 30 ) {
                    p->sensitivity_wide++;
                }
                break;

            case 1:
                if ( p->sensitivity_tight < 30 ) {
                    p->sensitivity_tight++;
                }
                break;


            case 2:
                if ( p->fov_wide < 90  ) {
                    p->fov_wide++;
                }
                break;

            case 3:
                if ( p->fov_tight < 40  ) {
                    p->fov_tight++;
                }
                break;




            default: break;
            }

        }



        return;
    }





}

 
 
/*** try again - not being such a smartass with the logic ***/
void process_input2( shooter_t *p, cont_cond_t cond ) {
    int hit_a_and_x = 0;
    float control_invert = 1.0;
    double perp_vector[4];
    double up[4] = {0.0, 1.0, 0.0, 0.0 };

    double forward_direction[4];

    float shoot_precision;



    
    check_pause( p, cond );




    /*** first find normalized direction in terms of yaw and pitch **/
    forward_direction[0] = cos( p->yaw );
    forward_direction[2] = sin( p->yaw );
    forward_direction[1] = sin( p->pitch );
    forward_direction[0] *= cos( p->pitch );
    forward_direction[2] *= cos( p->pitch );
     


    p->topwards[0] = cos( p->yaw );
    p->topwards[2] = sin( p->yaw );

    p->topwards[0] *= sin( p->pitch );
    p->topwards[2] *= sin( p->pitch );

    p->topwards[0] *= cos( p->roll );
    p->topwards[2] *= sin( p->roll );

    p->topwards[1] = sin( p->roll );



    /* determine heading and perpendicular vertors
     * v0.0.6: integrate roll - rotate up about forward
     *
     *
     *     
     */
     cross_product( up, forward_direction, perp_vector );
     cross_product( perp_vector, forward_direction, p->topwards );




    /* aiming with analog stick
     *  - precision is left trigger
     * v0.0.4: player preference
     *
     * like this to be a  mix of near + far values...
     *   interpolant
     *   probably needs to be worked on
     *
     */
    if ( 1 ) {
        float t = (float)cond.ltrig / 255.0;
        // shoot_precision =  16.0 / (  (float)(256 - cond.ltrig)  + 16.0 );
        // shoot_precision =  16.0 / (  (float)(cond.ltrig)  + 16.0 );
        shoot_precision = 2.0 /
            (
                t * (float)( p->sensitivity_tight + 40) + 
                (1.0-t) * (float)( p->sensitivity_wide)
             );
    }


#ifdef VERTICAL_LOOK_BOUND
    /* v0.0.3: impose bounds on pitch
     *  - due to shortcomings in glewLookAt()
     *
     */
    if ( 
        ( cond.joyy - 128 < 0 ) && ( p->pitch > -3.1415927/2.5f )
        ||
        ( cond.joyy - 128 > 0 ) && ( p->pitch < 3.1415927/2.5f )
        ) {
        
        p->pitch += shoot_precision * (float)( cond.joyy - 128 ) * 0.001;
    }
#else
    p->pitch += shoot_precision * (float)( cond.joyy - 128 ) * 0.001;
#endif
    p->yaw += shoot_precision * (float)( cond.joyx - 128 ) * 0.001;




    /* v0.0.4: A button for shield/brake
     *
     *
     *
     */
    p->braking = 0;
    if (!(cond.buttons & CONT_A)) {
       if ( p->velocity[0] * p->velocity[0] > 0.0001 )
           p->velocity[0] /= 2.0;

       if ( p->velocity[1] * p->velocity[1] > 0.0001 )
           p->velocity[1] /= 2.0;

       if ( p->velocity[2] * p->velocity[2] > 0.0001 )
           p->velocity[2] /= 2.0;

       p->braking = 1;
       return;
    }




     
    /* shoot logic - no bouncing on trigger
     *
     *
     */
    if ( cond.rtrig > 0 ) {
        int fire_shot = 0;
        int cooldown = 5;

        if ( p->laser_charge < MAX_LASER_CHARGE )
            p->laser_charge++;
        if ( p->transrtrig == 0 ) {
            fire_shot = 1;
        }
        if ( p->machine_gun > 1 ) {
            p->machine_gun--;
        }
        else if ( p->machine_gun == 1 ) {
            fire_shot = 1;
            p->machine_gun = cooldown;
        }
        /*** cancel for deep pull(laser) ***/
        if ( cond.rtrig > 120 ) {
            fire_shot = 0;
        }

        if ( fire_shot == 1 ) {


            /* add a shot to the scene
             *  v0.0.3: making shots faster
             *
             */
            if ( active_moving_shot_count < MAX_SHOTS ) {
                double shot_boost = 3.0;
                moving_shot_t *new_shot = malloc( sizeof( moving_shot_t) );

                new_shot->location[0] = p->location[0];
                new_shot->location[1] = p->location[1];
                new_shot->location[2] = p->location[2];

                new_shot->direction[0] = shot_boost * p->direction[0];
                new_shot->direction[1] = shot_boost * p->direction[1];
                new_shot->direction[2] = shot_boost * p->direction[2];

                /*** add ship velocity for truer shot ***/
                new_shot->direction[0] += p->velocity[0];
                new_shot->direction[1] += p->velocity[1];
                new_shot->direction[2] += p->velocity[2];

                new_shot->lifetime = 0;
                new_shot->owner = p;

                //   active_moving_shots[(  active_moving_shot_pointer + active_moving_shot_count ) % MAX_SHOTS] = new_shot;
                active_moving_shots[ active_moving_shot_count ] = new_shot;



                // active_moving_shot_pointer++;
                active_moving_shot_count++;
                // active_moving_shot_count %= MAX_SHOTS;


                /* v0.0.6: spread
                 *
                 *
                 *
                 *
                 */ 
                if ( p->spread_gun >= 1 ) {
                    float spread_factor = 0.15 * (float)(256 - p->zoom)/256.0  + 0.02;

                    if ( active_moving_shot_count < MAX_SHOTS ) {
                        double shot_boost = 3.0;
                        moving_shot_t *new_shot = malloc( sizeof( moving_shot_t) );

                        new_shot->location[0] = p->location[0];
                        new_shot->location[1] = p->location[1];
                        new_shot->location[2] = p->location[2];

                        new_shot->direction[0] = shot_boost * p->direction[0];
                        new_shot->direction[1] = shot_boost * p->direction[1];
                        new_shot->direction[2] = shot_boost * p->direction[2];

                        /*** v0.0.6: add perp component for spread ***/
                        new_shot->direction[0] += spread_factor * shot_boost * perp_vector[0];
                        new_shot->direction[1] += spread_factor * shot_boost * perp_vector[1];
                        new_shot->direction[2] += spread_factor * shot_boost * perp_vector[2];


                        /*** add ship velocity for truer shot ***/
                        new_shot->direction[0] += p->velocity[0];
                        new_shot->direction[1] += p->velocity[1];
                        new_shot->direction[2] += p->velocity[2];

                        new_shot->lifetime = 0;
                        new_shot->owner = p;

                        active_moving_shots[ active_moving_shot_count ] = new_shot;

                        active_moving_shot_count++;
                        active_moving_shot_count %= MAX_SHOTS;
                    }



                    /* v0.0.6: spread (other shot)
                     *
                     *
                     *
                     *
                     */
                    if ( active_moving_shot_count < MAX_SHOTS ) {
                        double shot_boost = 3.0;
                        moving_shot_t *new_shot = malloc( sizeof( moving_shot_t) );

                        new_shot->location[0] = p->location[0];
                        new_shot->location[1] = p->location[1];
                        new_shot->location[2] = p->location[2];

                        new_shot->direction[0] = shot_boost * p->direction[0];
                        new_shot->direction[1] = shot_boost * p->direction[1];
                        new_shot->direction[2] = shot_boost * p->direction[2];

                        /*** v0.0.6: add perp component for spread ***/
                        new_shot->direction[0] -= spread_factor * shot_boost * perp_vector[0];
                        new_shot->direction[1] -= spread_factor * shot_boost * perp_vector[1];
                        new_shot->direction[2] -= spread_factor * shot_boost * perp_vector[2];


                        /*** add ship velocity for truer shot ***/
                        new_shot->direction[0] += p->velocity[0];
                        new_shot->direction[1] += p->velocity[1];
                        new_shot->direction[2] += p->velocity[2];

                        new_shot->lifetime = 0;
                        new_shot->owner = p;

                        active_moving_shots[ active_moving_shot_count ] = new_shot;

                        active_moving_shot_count++;
                        active_moving_shot_count %= MAX_SHOTS;
                    }




                }





                /* v0.0.4: play a sound
                 *
                 *
                 */
#ifdef SOUND_EFFECTS
                //  snd_sfx_play(2, 240, 0);
                snd_sfx_play(3, 240, 0 );
                snd_sfx_play(3, 240, 1 );
                snd_sfx_play(3, 240, 2 );
#endif
            }




            total_shot_count++;

            p->transrtrig = 1;
        }


    }
    else {
        if ( p->laser_charge > 0 )
            p->laser_charge--;
        p->transrtrig = 0;
    }

     





     
    /* shoot logic - no bouncing on trigger
     *
     *
     */
    if ( cond.rtrig > 253 ) {


        if ( p->transrtrigdeep == 0 ) {

            if ( p->laser_charge >= MAX_LASER_CHARGE ) {



                shot_t *new_shot = malloc( sizeof( shot_t) );

                /*** init the shot ***/
                new_shot->origin[0] = p->location[0];
                new_shot->origin[1] = p->location[1];
                new_shot->origin[2] = p->location[2];
                new_shot->origin[3] = p->location[3];
                new_shot->direction[0] = p->direction[0];
                new_shot->direction[1] = p->direction[1];
                new_shot->direction[2] = p->direction[2];
                new_shot->direction[3] = p->direction[3];

                new_shot->owner = p;
                new_shot->potent = MAX_SHOT_POTENCY;


                active_shots[ active_shot_count++ ] = new_shot;


                p->laser_charge = 0;

                total_shot_count++;


                /*** this line indicates an off ***/
                p->transrtrigdeep = 1;

#ifdef SOUND_EFFECTS
                snd_sfx_play(4, 240, 2);
                snd_sfx_play(4, 240, 1);
                snd_sfx_play(4, 240, 0);
#endif
            }

        }


    }
    else {
        p->transrtrigdeep = 0;
    }

     



    p->zoom = cond.ltrig;


     
    /* left trigger - braking
     *
     *
     */
    if ( cond.ltrig > 0 ) {
    }
    else {

        shoot_precision /= 20.0; // hackaround


        /*** frontstep ***/
        if (!(cond.buttons & CONT_Y)) {
            p->velocity[0] += shoot_precision * forward_direction[0];
            p->velocity[1] += shoot_precision * forward_direction[1];
            p->velocity[2] += shoot_precision * forward_direction[2];
        }

        /*** sidestep ***/
        if (!(cond.buttons & CONT_B)) {
            p->velocity[0] += shoot_precision * perp_vector[0];
            p->velocity[1] += shoot_precision * perp_vector[1];
            p->velocity[2] += shoot_precision * perp_vector[2];
        }

        // if (!(cond.buttons & CONT_X)) {
        if (!(cond.buttons & CONT_X)) {
            p->velocity[0] -= shoot_precision * perp_vector[0];
            p->velocity[1] -= shoot_precision * perp_vector[1];
            p->velocity[2] -= shoot_precision * perp_vector[2];
        }
  

        /*** upstep - reversed***/
        if (!(cond.buttons & CONT_DPAD_DOWN)) {
            p->velocity[0] += shoot_precision * p->topwards[0];
            p->velocity[1] += shoot_precision * p->topwards[1];
            p->velocity[2] += shoot_precision * p->topwards[2];
        }
        if (!(cond.buttons & CONT_DPAD_UP)) {
            p->velocity[0] -= shoot_precision * p->topwards[0];
            p->velocity[1] -= shoot_precision * p->topwards[1];
            p->velocity[2] -= shoot_precision * p->topwards[2];
        }


        /*** v0.0.6: roll ***/
        if(!(cond.buttons & CONT_DPAD_LEFT)) {
            p->roll -= 0.01;
        }
        if(!(cond.buttons & CONT_DPAD_RIGHT)) {
            p->roll += 0.01;

        }

        /*** normalize to unit velocity (maximum speed) ***/
        if ( 1 ) {
            float sum = 0.0;
            sum += p->velocity[0]  * p->velocity[0];
            sum += p->velocity[1]  * p->velocity[1];
            sum += p->velocity[2]  * p->velocity[2];
            sum = sqrt(sum);
            if ( sum > 1.0 ) {
                p->velocity[0] /= sum;
                p->velocity[1] /= sum;
                p->velocity[2] /= sum;
            }
        }


    }


}

 
